Loading...
Searching...
No Matches
casacore::ExtendLattice< T > Class Template Reference
lattices package (libcasa_lattices) » Lattices_module

More...

`#include <ExtendLattice.h>`

## Public Member Functions

| ExtendLattice ()
| The default constructor creates a ExtendLattice that is useless for just about everything, except that it can be assigned to with the assignment operator.
| ExtendLattice (const Lattice< T > &lattice, const IPosition &newShape, const IPosition &extendAxes, const IPosition &stretchAxes)
| Create a ExtendLattice from a Lattice.
| ExtendLattice (const MaskedLattice< T > &lattice, const IPosition &newShape, const IPosition &newAxes, const IPosition &stretchAxes)
| ExtendLattice (const ExtendLattice< T > &other)
| Copy constructor (reference semantics).
virtual | ~ExtendLattice ()
ExtendLattice< T > & | operator= (const ExtendLattice< T > &other)
| Assignment (reference semantics).
virtual MaskedLattice< T > * | cloneML () const
| Make a copy of the object (reference semantics).
virtual Bool | isMasked () const
| Is the lattice masked?
virtual Bool | isPersistent () const
| An ExtendLattice is not persistent.
virtual Bool | isPaged () const
| Is the ExtendLattice paged to disk?
virtual Bool | isWritable () const
| An ExtendLattice is not writable.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle locking of the ExtendLattice which is delegated to its parent.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data.
virtual void | tempClose ()
| Close the Lattice temporarily (if it is paged to disk).
virtual void | reopen ()
| If needed, reopen a temporarily closed Lattice.
virtual Bool | hasPixelMask () const
| Does the ExtendLattice have a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask.
virtual Lattice< Bool > & | pixelMask ()
virtual const LatticeRegion * | getRegionPtr () const
| Get the region used (always returns 0).
virtual IPosition | shape () const
| Returns the shape of the ExtendLattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the parent lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the recommended maximum number of pixels to include in the cursor of an iterator.
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &section)
| Do the actual getting of an array of values.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Putting data is not possible.
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Get a section of the mask.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Get the best cursor shape.
Public Member Functions inherited from casacore::MaskedLattice< T >
| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual T | getAt (const IPosition &where) const
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | set (const T &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Private Member Functions

void | setPtr (Lattice< T > *latticePtr, MaskedLattice< T > *maskLatPtr)
| Set the various pointer needed to construct the object.
Bool | getMaskDataSlice (Array< Bool > &buffer, const Slicer &section)
| Get mask data from mask.

## Private Attributes

Lattice< T > * | itsLatticePtr
MaskedLattice< T > * | itsMaskLatPtr
Bool | itsHasPixelMask
ExtendLattice< Bool > * | itsPixelMask
ExtendSpecifier | itsExtendSpec

## Additional Inherited Members

Protected Member Functions inherited from casacore::MaskedLattice< T >
MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

template<class T>
class casacore::ExtendLattice< T >

An extension of a Lattice or MaskedLattice

### Intended use:

Public interface

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice
- LatticeRegion

### Synopsis

An ExtendLattice is a lattice virtually extending another lattice by stretching axes with length 1 and/or by adding new axes. It is useful for e.g. LEL to have the same shapes for lattices. An ExtendLattice is not writable (since many pixels map to the same underlying pixel).

### Example

### Template Type Argument Requirements (T)

- Any type that can be used by the Tables System can also be used by this class.

Definition at line 75 of file ExtendLattice.h.

## Constructor & Destructor Documentation

## ExtendLattice() [1/4]

template<class T>

casacore::ExtendLattice< T >::ExtendLattice | ( |  | ) |

The default constructor creates a ExtendLattice that is useless for just about everything, except that it can be assigned to with the assignment operator.

Referenced by ExtendLattice(), and operator=().

## ExtendLattice() [2/4]

template<class T>

casacore::ExtendLattice< T >::ExtendLattice | ( | const Lattice< T > & | lattice,
|  | const IPosition & | newShape,
|  | const IPosition & | extendAxes,
|  | const IPosition & | stretchAxes )

Create a ExtendLattice from a Lattice.

newShape gives the new shape.
newAxes gives the new axes in newShape.
stretchAxes gives the stretched axes in newShape.
E.g. lattice has shape [32,1,5,1], newShape=[32,1,4,5,10], newAxes=[2], and stretchAxes=[4]. It means that axes 2 in the newShape is a new axes and that axes 4 in the new shape is stretched. The other axes in the new shape have to match the other axes in the old shape. Note that stretched axes have to have length 1 in the old shape.

## ExtendLattice() [3/4]

template<class T>

casacore::ExtendLattice< T >::ExtendLattice | ( | const MaskedLattice< T > & | lattice,
|  | const IPosition & | newShape,
|  | const IPosition & | newAxes,
|  | const IPosition & | stretchAxes )

References casacore::MaskedLattice< T >::MaskedLattice().

## ExtendLattice() [4/4]

template<class T>

casacore::ExtendLattice< T >::ExtendLattice | ( | const ExtendLattice< T > & | other | ) |

Copy constructor (reference semantics).

References ExtendLattice().

## ~ExtendLattice()

template<class T>

virtual casacore::ExtendLattice< T >::~ExtendLattice | ( |  | ) |

virtual

## Member Function Documentation

## advisedMaxPixels()

template<class T>

virtual uInt casacore::ExtendLattice< T >::advisedMaxPixels | ( |  | ) | const

virtual

This function returns the recommended maximum number of pixels to include in the cursor of an iterator.

Reimplemented from casacore::Lattice< T >.

## cloneML()

template<class T>

virtual MaskedLattice< T > * casacore::ExtendLattice< T >::cloneML | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::MaskedLattice< T >.

References casacore::MaskedLattice< T >::MaskedLattice().

## doGetMaskSlice()

template<class T>

virtual Bool casacore::ExtendLattice< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Get a section of the mask.

Reimplemented from casacore::MaskedLattice< T >.

## doGetSlice()

template<class T>

virtual Bool casacore::ExtendLattice< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual getting of an array of values.

Implements casacore::Lattice< T >.

## doNiceCursorShape()

template<class T>

virtual IPosition casacore::ExtendLattice< T >::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Get the best cursor shape.

Reimplemented from casacore::LatticeBase.

## doPutSlice()

template<class T>

virtual void casacore::ExtendLattice< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

Putting data is not possible.

Implements casacore::Lattice< T >.

## flush()

template<class T>

virtual void casacore::ExtendLattice< T >::flush | ( |  | ) |

virtual

Flush the data.

Reimplemented from casacore::LatticeBase.

## getMaskDataSlice()

template<class T>

Bool casacore::ExtendLattice< T >::getMaskDataSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

private

Get mask data from mask.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::ExtendLattice< T >::getRegionPtr | ( |  | ) | const

virtual

Get the region used (always returns 0).

Implements casacore::MaskedLattice< T >.

## hasLock()

template<class T>

virtual Bool casacore::ExtendLattice< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## hasPixelMask()

template<class T>

virtual Bool casacore::ExtendLattice< T >::hasPixelMask | ( |  | ) | const

virtual

Does the ExtendLattice have a pixelmask?

Reimplemented from casacore::MaskedLattice< T >.

## isMasked()

template<class T>

virtual Bool casacore::ExtendLattice< T >::isMasked | ( |  | ) | const

virtual

Is the lattice masked?

It is if its parent lattice is masked.

Reimplemented from casacore::MaskedLattice< T >.

## isPaged()

template<class T>

virtual Bool casacore::ExtendLattice< T >::isPaged | ( |  | ) | const

virtual

Is the ExtendLattice paged to disk?

Reimplemented from casacore::LatticeBase.

## isPersistent()

template<class T>

virtual Bool casacore::ExtendLattice< T >::isPersistent | ( |  | ) | const

virtual

An ExtendLattice is not persistent.

Reimplemented from casacore::LatticeBase.

## isWritable()

template<class T>

virtual Bool casacore::ExtendLattice< T >::isWritable | ( |  | ) | const

virtual

An ExtendLattice is not writable.

Reimplemented from casacore::LatticeBase.

## lock()

template<class T>

virtual Bool casacore::ExtendLattice< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle locking of the ExtendLattice which is delegated to its parent.

It is strongly recommended to use class LatticeLocker to handle lattice locking. It also contains a more detailed explanation of the locking process.

Reimplemented from casacore::LatticeBase.

## name()

template<class T>

virtual String casacore::ExtendLattice< T >::name | ( | Bool | stripPath = False | ) | const

virtual

Return the name of the parent lattice.

Reimplemented from casacore::LatticeBase.

References casacore::False.

## ok()

template<class T>

virtual Bool casacore::ExtendLattice< T >::ok | ( |  | ) | const

virtual

Check class internals - used for debugging.

Should always return True

Reimplemented from casacore::LatticeBase.

## operator=()

template<class T>

ExtendLattice< T > & casacore::ExtendLattice< T >::operator= | ( | const ExtendLattice< T > & | other | ) |

Assignment (reference semantics).

References ExtendLattice().

## pixelMask() [1/2]

template<class T>

virtual Lattice< Bool > & casacore::ExtendLattice< T >::pixelMask | ( |  | ) |

virtual

Reimplemented from casacore::MaskedLattice< T >.

## pixelMask() [2/2]

template<class T>

virtual const Lattice< Bool > & casacore::ExtendLattice< T >::pixelMask | ( |  | ) | const

virtual

Get access to the pixelmask.

An exception is thrown if the ExtendLattice does not have a pixelmask.

Reimplemented from casacore::MaskedLattice< T >.

## reopen()

template<class T>

virtual void casacore::ExtendLattice< T >::reopen | ( |  | ) |

virtual

If needed, reopen a temporarily closed Lattice.

Reimplemented from casacore::LatticeBase.

## resync()

template<class T>

virtual void casacore::ExtendLattice< T >::resync | ( |  | ) |

virtual

Resynchronize the Lattice object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.

Reimplemented from casacore::LatticeBase.

## setPtr()

template<class T>

void casacore::ExtendLattice< T >::setPtr | ( | Lattice< T > * | latticePtr,
|  | MaskedLattice< T > * | maskLatPtr )

private

Set the various pointer needed to construct the object.

One of the pointers should be zero. It takes over the pointer and deletes the object in the destructor.

References casacore::MaskedLattice< T >::MaskedLattice().

## shape()

template<class T>

virtual IPosition casacore::ExtendLattice< T >::shape | ( |  | ) | const

virtual

Returns the shape of the ExtendLattice.

Implements casacore::LatticeBase.

## tempClose()

template<class T>

virtual void casacore::ExtendLattice< T >::tempClose | ( |  | ) |

virtual

Close the Lattice temporarily (if it is paged to disk).

It'll be reopened automatically when needed or when reopen is called explicitly.

Reimplemented from casacore::LatticeBase.

## unlock()

template<class T>

virtual void casacore::ExtendLattice< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## itsExtendSpec

template<class T>

ExtendSpecifier casacore::ExtendLattice< T >::itsExtendSpec

private

Definition at line 205 of file ExtendLattice.h.

## itsHasPixelMask

template<class T>

Bool casacore::ExtendLattice< T >::itsHasPixelMask

private

Definition at line 203 of file ExtendLattice.h.

## itsLatticePtr

template<class T>

Lattice<T>* casacore::ExtendLattice< T >::itsLatticePtr

private

Definition at line 201 of file ExtendLattice.h.

## itsMaskLatPtr

template<class T>

MaskedLattice<T>* casacore::ExtendLattice< T >::itsMaskLatPtr

private

Definition at line 202 of file ExtendLattice.h.

## itsPixelMask

template<class T>

ExtendLattice<Bool>* casacore::ExtendLattice< T >::itsPixelMask

private

Definition at line 204 of file ExtendLattice.h.

The documentation for this class was generated from the following files:

- images/Images/ExtendImage.h
- lattices/Lattices/ExtendLattice.h